#!/usr/bin/python -tt
# -*- coding: utf-8 -*-

import requests
import time
from bs4 import BeautifulSoup
import os
import csv
import pandas as pd

script_dir = os.path.dirname(__file__)
file = pd.read_csv(script_dir+"/"+"logs-bpi-news-2017-08-14-2017-08-21.csv")
file_dict = file.to_dict(orient='records')
for row in file_dict:
	row["country"]=""
	if row["domain"] is not None:
		site = row["domain"]
		url ="https://www.alexa.com/siteinfo/"+str(site)
		response = requests.get(url)
		soup = BeautifulSoup(response.text, "html.parser")
		if soup.find('span',{'data-cat':"countryRank"}):
			country_rank_span = soup.find('span',{'data-cat':"countryRank"})
			if country_rank_span.find('a'):
				country = country_rank_span.find('a')
				country = country.get_text()
				print(country)
				row["country"]=country
fieldnames = file_dict[0].keys()
csv_file = script_dir+"/"+"messed-"+"logs-bpi-news-2017-08-14-2017-08-21.csv"
with open(csv_file, "w") as csvfile:
	writer = csv.DictWriter(csvfile,fieldnames=fieldnames)
	writer.writeheader()
	for data in file_dict:
		writer.writerow(data)
	csvfile.close()