#!/usr/bin/python -tt
# -*- coding: utf-8 -*-

# this python file takes the cleaned csv file, and adds a time column
# for utc offset of country in "country" column

#for scraping
import requests
from bs4 import BeautifulSoup
#for csv
import csv
import pandas as pd
#for file directories
import os
from os import listdir
from os.path import isfile, join
import time

script_dir = os.path.dirname(__file__)
file_csv = pd.read_csv(script_dir+"/scraped-and-cleaned-logs-bpi-news-2017-08-14-2017-08-21.csv",sep=',', header=0)
file_dict = file_csv.to_dict(orient='records')
for row in file_dict:
	row["country_utc"] = ""
	if row["country"] is not None:
		country = row["country"]
		url2 = "https://www.timeanddate.com/worldclock/"+str(country)
		response2 = requests.get(url2)
		soup2 = BeautifulSoup(response2.text, "html.parser")
		if soup2.find('div',{'class':"tzmp_fig_utc"}):
			time_zone = soup2.find('div',{'class':"tzmp_fig_utc"})
			time_zone = time_zone.get_text()
			time_zone = time_zone[4:]
			row["country_utc"] = time_zone
			print(time_zone)
fieldnames = file_dict[1].keys()
csv_file = script_dir+"/w_utc_scraped-and-cleaned-logs-bpi-news-2017-08-14-2017-08-21.csv"
with open(csv_file, "w") as csvfile:
	writer = csv.DictWriter(csvfile,fieldnames=fieldnames)
	writer.writeheader()
	for data in file_dict:
		writer.writerow(data)
	csvfile.close()