#!/usr/bin/python -tt
# -*- coding: utf-8 -*-

# this python file takes table with alexa.com data,
# to sanity check with similarweb.com for country of news agency (failed)
# and adds host ip address and host country from cutestats.com (succeeded)

#for scraping
import requests
from bs4 import BeautifulSoup
#for csv
import csv
import pandas as pd
#for file directories
import os
from os import listdir
from os.path import isfile, join
import time



script_dir = os.path.dirname(__file__)

files = [f for f in listdir(script_dir+"/messed-logs-bpi-news-2017-08-14-2017-08-21/groupsoften/") if isfile(join(script_dir+"/messed-logs-bpi-news-2017-08-14-2017-08-21/groupsoften/", f))]

# because of difficulty scraping entire file's links at once, I've splitted the 
# file into several different .csv files.
# the .csv files are splitted in excel using the code
# from here: https://www.extendoffice.com/documents/excel/1175-excel-split-rows-into-multiple-worksheets.html

#file = "12_21.csv"

for file in files:
	if file != ".DS_Store":
		print(file)
		file_csv = pd.read_csv(script_dir+"/messed-logs-bpi-news-2017-08-14-2017-08-21/groupsoften/"+file,sep=',', header=0)
		file_dict = file_csv.to_dict(orient='records')
		for row in file_dict:
			#row["country_bysimilarweb"]=""
			row["host_ip"] = ""
			row["host_country"] = ""
			row["host_lat"] = ""
			row["host_lon"] = ""
			if row["domain"] is not None:
				site = row["domain"]
				# the below sanity check section is not functional, because of
				# very low requests limit from the website (according to google),
				# due to the amount of people who have tried to scrape it

				# #gets sanity check for news agency country from similarweb.com
				# url ="https://www.similarweb.com/website/"+str(site)
				# response = requests.get(url)
				# soup = BeautifulSoup(response.text, "html.parser")
				# if soup.find('li',{'class':"websiteRanks-item js-countryRank"}):
				# 	country_rank_li = soup.find('li',{'class':"websiteRanks-item js-countryRank"})
				# 	if country_rank_li.find('div',{'class':"websiteRanks-header"}):
				# 		country_rank_div2 = country_rank_li.find('div',{'class':"websiteRanks-header"})
				# 		country_rank_div = country_rank_div2.find('div',{'class':"websiteRanks-name"})
				# 		country_rank_link = country_rank_div.find('a')
				# 		country = country_rank_link.get_text()
				# 		print("country" + country)
				# 		row["countrybysimilarweb"]=country

				# gets IP, lat, long, country of host from cutestat.com
				# used selector path because their html is written in a headach-y way
				url2 = "https://www.cutestat.com/process.php?q="+str(site)+"&t=domain"
				response2 = requests.get(url2)
				soup2 = BeautifulSoup(response2.text, "html.parser")
				#gets ip
				if soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(1) > span'):
					ip_span = soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(1) > span')[0]
					ip = ip_span.get_text()
					row["host_ip"] = ip
				#gets host country
				if soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(2) > span'):
					host_country_link_a = soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(2) > span')[0]
					host_country = host_country_link_a.get("title")
					row["host_country"] = host_country
					print(host_country)
					#print("host: " + host_country)
				#gets lat
				if soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(3) > span'):
					lat = soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(3) > span')[0]
					lat = lat.get_text()
					row["host_lat"] = lat
				#gets long
				if soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(4) > span'):
					lon = soup2.select('body > div.flare > div > div > div.content_body_wrapper > div > div > div > div.span7.content_main > div > div.stat_details > div:nth-child(6) > div.span4 > div > div:nth-child(4) > span')[0]
					lon = lon.get_text()
					row["host_lon"] = lon
		fieldnames = file_dict[1].keys()
		csv_file = script_dir+"/outputbyten/"+"messed-messed-"+"logs-bpi-news-2017-08-14-2017-08-21_"+file
		with open(csv_file, "w") as csvfile:
			writer = csv.DictWriter(csvfile,fieldnames=fieldnames)
			writer.writeheader()
			for data in file_dict:
				writer.writerow(data)
			print(file)
			csvfile.close()
		# rest before scraping more, to avoid getting blasted
		time.sleep(20)