#!/usr/bin/python -tt
# -*- coding: utf-8 -*-

# this python file takes the cleaned csv file with utc offset,
# and adds geo-coordinates of "country" column countries
# from wikipedia scraping,
# then calculates the distance of each country from the library

#for scraping
import requests
from bs4 import BeautifulSoup
#for csv
import csv
import pandas as pd
#for file directories
import os
from os import listdir
from os.path import isfile, join
import time
# for calculating geographic distance from France
# I experimented with haversine function, however,
# the geopy library is more accurate
from geopy.distance import distance

script_dir = os.path.dirname(__file__)

france_coord = 48.85,2.35

file_csv = pd.read_csv(script_dir+"/w_utc_scraped-and-cleaned-logs-bpi-news-2017-08-14-2017-08-21.csv",sep=',', header=0)
file_dict = file_csv.to_dict(orient='records')

for row in file_dict:
	row["country_lat"] = ""
	row["country_lon"] = 0,
	row["distance_from_bpi"] = ""
	if row["country"] is not "nan":
		print(row["country"])
		if " " in row["country"]:
			wikicountry = row["country"]
			wikicountry = wikicountry.replace(" ", "_")
		elif "Congo" in row["country"]:
			wikicountry = "Democratic_Republic_of_the_Congo"
		else:
			wikicountry = row["country"]
		url2 = "https://en.wikipedia.org/wiki/"+wikicountry
		response2 = requests.get(url2)
		soup = BeautifulSoup(response2.text, "html.parser")
		if soup.find('span',{'class':"geo-nondefault"}):
			geo_span = soup.find('span',{'class':"geo-nondefault"})
			if geo_span.find('span',{'class':"geo-dec"}):
				latlon = geo_span.find('span',{'class':"geo-dec"})
				latlon = latlon.get_text()
				lat = latlon.split(" ")[0];
				lon = latlon.split(" ")[1];
				print(lat)
				print(lon)
				if "N" in lat:
					lat = float(lat[:-2])
				elif "S" in lat:
					lat = float(lat[:-2])
					lat = lat*(-1)
				if "E" in lon:
					lon = float(lon[:-2])
				elif "W" in lon:
					lon = float(lon[:-2])
					lon = lon*(-1)
				print(lat)
				print(lon)
				coord = (lat,lon)
				row["country_lat"] = lat
				row["country_lon"] = lon
				row["distance_from_bpi"] = distance(france_coord, coord).m/1000
				print(row["distance_from_bpi"])
fieldnames = file_dict[1].keys()
csv_file = script_dir+"/w_distance_and_utc_scraped-and-cleaned-logs-bpi-news-2017-08-14-2017-08-21.csv"
with open(csv_file, "w") as csvfile:
	writer = csv.DictWriter(csvfile,fieldnames=fieldnames)
	writer.writeheader()
	for data in file_dict:
		writer.writerow(data)
	csvfile.close()